local Quad =  love.graphics.newQuad

function love.load()
  --Images
  hills = love.graphics.newImage("Hills.png")
  HeroSprite = love.graphics.newImage("Hero.png")
  CloudImg = love.graphics.newImage("Cloud.png")
  
  --Sound
  --Music = love.audio.newSource("")
  --love.audio.play(Music)
  --Music:setVolume(.05)
  MainTheme = love.audio.newSource("MainTheme.wav")
  MainTheme:setVolume(.3)
  MainTheme:setLooping(true)
  MainTheme:play()
  
 --Particle Engine
 dust = love.graphics.newImage("Dust.png")
  p = love.graphics.newParticleSystem(dust, 10)
 
  p:setEmissionRate          (6)
  p:setLifetime              (1)
  p:setParticleLife          (.30)
  p:setDirection             (10)
  p:setSpread                (2)
  p:setSpeed                 (10, 30)
  p:setGravity               (0)
  p:setRadialAcceleration    (100)
  p:setTangentialAcceleration(0)
  p:setSizes                 (1)
  p:setSizeVariation         (0.5)
  p:setRotation              (0)
  p:setSpin                  (0)
  p:setSpinVariation         (0)
  p:setColors                (200, 0, 0, 12)
  p:stop();
  
  --Playable Character
  Hero = {}
  Hero.x = 10
  Hero.y = 400
  Hero.speed = 125
  
  --Cloud Parameters
  Cloud = {}
  Cloud.x = 0
  Cloud.y = 50
  Cloud.speed = 5
  
  quads = {
    right = {
      Quad( 96, 64, 30, 32, 382, 256);
      Quad(126, 64, 30, 32, 382, 256);
      Quad(156, 64, 30, 32, 382, 256);
   };
   left = {
     Quad( 96, 32, 30, 32, 382, 256);
     Quad(126, 32, 30, 32, 382, 256);
     Quad(156, 32, 30, 32, 382, 256);
   };
   standing = {
     Quad(126, 0, 30, 32, 382, 256);
   };
  }
  iterator = 1
  max = 3
  timer = 0
  moving = false
  direction = "standing"  
end

function love.update(dt)
  
  --Switches between sprite frames, if moving
  if moving then
    timer = timer + dt
    if timer > 0.2 then
      timer = 0
      iterator = iterator + 1
      if iterator > max then
        iterator = 1
      end
    end
  end
  
  --Moving the character
  if love.keyboard.isDown("right") then
    Hero.x = Hero.x + (Hero.speed * dt)
    if love.keyboard.isDown(" ") then
      p:start()
      Hero.x = Hero.x+((Hero.speed + 100) * dt)
      p:setPosition(Hero.x, Hero.y + 10)
    end
  elseif love.keyboard.isDown("left") then
    Hero.x = Hero.x - (Hero.speed * dt)
    if love.keyboard.isDown(" ") then
      p:start()
      Hero.x = Hero.x -((Hero.speed + 100) * dt)
      p:setPosition(Hero.x, Hero.y + 10)
    end
  else
    p:stop()
  end
  p:update(dt)

  
  --Prevents player from going off screen
  if Hero.x > 810 then
    Hero.x = -20
  elseif Hero.x < -30 then
    Hero.x = 810
  end
  
  
  --Move the cloud
  Cloud.x = Cloud.x + (Cloud.speed * dt)
  if Cloud.x >= 800 then
    Cloud.x = 0 - 200
  end  
end

function love.draw()
  
  --Sky
  love.graphics.setColor(12,194,255)
  love.graphics.rectangle("fill", 0, 0, 800,300)
  
 --Cloud
  love.graphics.setColor(255,255,255)
  love.graphics.draw(CloudImg, Cloud.x, Cloud.y)
 
 --Ground
  love.graphics.setColor(65,128,22)
  love.graphics.rectangle("fill", 0, 300, 800, 300)
    
  --Hills
  love.graphics.setColor(255,255,255)
  love.graphics.draw(hills,0,-20)
  
  --Road
  love.graphics.setColor(201, 155, 85, 255)
  love.graphics.rectangle("fill", 0, 400, 800, 50)
  
  --Dust Particle
  love.graphics.draw(p,20, 20)
  
  --Hero
  love.graphics.setColor(255,255,255)
  love.graphics.drawq(HeroSprite, quads[direction][iterator], Hero.x, Hero.y)
end

function love.keypressed(key, unicode)
  if key == "left" then
    moving = true
    direction = "left"
  elseif key == "right" then
    moving = true
    direction = "right"
  end
end

function love.keyreleased(key)
  if key == "left" or key == "right" then
    direction = "standing"
    iterator = 1
    moving = false
  end
end


